package labss.lang.il.model.impl;

import java.io.*;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */

public class NotExpression implements Expression {
	private Expression exp;

  public NotExpression(Expression exp) {
    this.exp = exp;
  }

  public void prettyPrint(PrintStream out) {
    out.print(" ! ");
    exp.prettyPrint(out);
  }

  public Literal evaluate() {
    return (exp.evaluate().booleanValue()) ? BooleanLiteral.FALSE : BooleanLiteral.TRUE;
  }
}