package labss.lang.il.model.impl;

import java.io.*;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */

public class BlockStatement implements Statement {
	private Statement[] stm;

	public BlockStatement(Statement[] stm) {
		this.stm = stm;
	}

	public void prettyPrint(PrintStream out) {
		for (int i = 0; i < stm.length; i++)
			stm[i].prettyPrint(out);
	}

	public void execute() {
		for (int i = 0; i < stm.length; i++)
			stm[i].execute();
	}
}